jjb: babeltrace: use --enable-asan (on some builds)
[lttng-ci.git] / scripts / babeltrace / build.sh
index d545b9988ae7cd25f3ae2b37bfaa89d3994c5f7c..1d03f72ab7b1811d26ad2fff7ace4d6e54f626cb 100755 (executable)
@@ -1,6 +1,7 @@
-#!/bin/bash -exu
+#!/bin/bash
 #
-# Copyright (C) 2015 - Jonathan Rajotte-Julien <jonathan.rajotte-julien@efficios.com>
+# Copyright (C) 2015 Jonathan Rajotte-Julien <jonathan.rajotte-julien@efficios.com>
+# Copyright (C) 2016-2020 Michael Jeanson <mjeanson@efficios.com>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
+set -exu
 
-# Create build directory
-rm -rf $WORKSPACE/build
-mkdir -p $WORKSPACE/build
+# Version compare functions
+vercomp () {
+    set +u
+    if [[ "$1" == "$2" ]]; then
+        return 0
+    fi
+    local IFS=.
+    # Ignore the shellcheck warning, we want splitting to happen based on IFS.
+    # shellcheck disable=SC2206
+    local i ver1=($1) ver2=($2)
+    # fill empty fields in ver1 with zeros
+    for ((i=${#ver1[@]}; i<${#ver2[@]}; i++)); do
+        ver1[i]=0
+    done
+    for ((i=0; i<${#ver1[@]}; i++)); do
+        if [[ -z ${ver2[i]} ]]; then
+            # fill empty fields in ver2 with zeros
+            ver2[i]=0
+        fi
+        if ((10#${ver1[i]} > 10#${ver2[i]})); then
+            return 1
+        fi
+        if ((10#${ver1[i]} < 10#${ver2[i]})); then
+            return 2
+        fi
+    done
+    set -u
+    return 0
+}
 
-PREFIX="$WORKSPACE/build"
+# Shellcheck flags the following functions that are unused as "unreachable",
+# ignore that.
+
+# shellcheck disable=SC2317
+verlte() {
+    vercomp "$1" "$2"
+    local res="$?"
+    [ "$res" -eq "0" ] || [ "$res" -eq "2" ]
+}
+
+# shellcheck disable=SC2317
+verlt() {
+    vercomp "$1" "$2"; local res="$?"
+    [ "$res" -eq "2" ]
+}
+
+# shellcheck disable=SC2317
+vergte() {
+    vercomp "$1" "$2"; local res="$?"
+    [ "$res" -eq "0" ] || [ "$res" -eq "1" ]
+}
+
+# shellcheck disable=SC2317
+vergt() {
+    vercomp "$1" "$2"; local res="$?"
+    [ "$res" -eq "1" ]
+}
+
+# shellcheck disable=SC2317
+verne() {
+    vercomp "$1" "$2"; local res="$?"
+    [ "$res" -ne "0" ]
+}
+
+failed_configure() {
+    # Assume we are in the configured build directory
+    echo "#################### BEGIN config.log ####################"
+    cat config.log
+    echo "#################### END config.log ####################"
+    exit 1
+}
+
+
+# Required variables
+WORKSPACE=${WORKSPACE:-}
+
+platform=${platform:-}
+conf=${conf:-}
+build=${build:-}
+cc=${cc:-}
+
+# Controls if the tests are run
+BABELTRACE_RUN_TESTS="${BABELTRACE_RUN_TESTS:=yes}"
+
+SRCDIR="$WORKSPACE/src/babeltrace"
+TMPDIR="$WORKSPACE/tmp"
+PREFIX="/build"
+
+# Create tmp directory
+rm -rf "$TMPDIR"
+mkdir -p "$TMPDIR"
+
+export TMPDIR
+export CFLAGS="-g -O2"
+
+# Set compiler variables
+case "$cc" in
+gcc)
+    export CC=gcc
+    export CXX=g++
+    ;;
+gcc-*)
+    export CC=gcc-${cc#gcc-}
+    export CXX=g++-${cc#gcc-}
+    ;;
+clang)
+    export CC=clang
+    export CXX=clang++
+    ;;
+clang-*)
+    export CC=clang-${cc#clang-}
+    export CXX=clang++-${cc#clang-}
+    ;;
+*)
+    if [ "x$cc" != "x" ]; then
+           export CC="$cc"
+    fi
+    ;;
+esac
+
+if [ "x${CC:-}" != "x" ]; then
+    echo "Selected compiler:"
+    "$CC" -v
+fi
 
 # Set platform variables
-case "$arch" in
-solaris10)
-    MAKE=gmake
-    TAR=gtar
-    NPROC=gnproc
-    BISON=bison
-    YACC="$BISON -y"
-    ;;
-solaris11)
-    MAKE=gmake
-    TAR=gtar
-    NPROC=nproc
-    BISON="/opt/csw/bin/bison"
-    YACC="$BISON -y"
-    export PATH="$PATH:/usr/perl5/bin"
-    ;;
-macosx)
-    MAKE=make
-    TAR=tar
-    NPROC="getconf _NPROCESSORS_ONLN"
-    BISON="bison"
-    YACC="$BISON -y"
+case "$platform" in
+macos*)
+    export MAKE=make
+    export TAR=tar
+    export NPROC="getconf _NPROCESSORS_ONLN"
     export PATH="/opt/local/bin:/opt/local/sbin:/usr/local/bin:/usr/bin:/bin:/usr/sbin:/sbin"
-    export CFLAGS="-I/opt/local/include"
+    export CPPFLAGS="-I/opt/local/include"
     export LDFLAGS="-L/opt/local/lib"
+    export PYTHON="python3"
+    export PYTHON_CONFIG="python3-config"
+    ;;
+
+freebsd*)
+    export MAKE=gmake
+    export TAR=tar
+    export NPROC="getconf _NPROCESSORS_ONLN"
+    export CPPFLAGS="-I/usr/local/include"
+    export LDFLAGS="-L/usr/local/lib"
+    export PYTHON="python3"
+    export PYTHON_CONFIG="python3-config"
+
+    # For bt 1.5
+    export YACC="bison -y"
     ;;
+
 *)
-    MAKE=make
-    TAR=tar
-    NPROC=nproc
-    BISON=bison
-    YACC="$BISON -y"
+    export MAKE=make
+    export TAR=tar
+    export NPROC=nproc
+    export PYTHON="python3"
+    export PYTHON_CONFIG="python3-config"
     ;;
 esac
 
-# Set configure options for each build configuration
-CONF_OPTS=""
+# Print build env details
+print_os || true
+print_tooling || true
+
+# Enter the source directory
+cd "$SRCDIR"
+
+# Run bootstrap in the source directory prior to configure
+./bootstrap
+
+# Get source version from configure script
+eval "$(grep '^PACKAGE_VERSION=' ./configure)"
+PACKAGE_VERSION=${PACKAGE_VERSION//\-pre*/}
+
+# Enable dev mode by default for BT 2.0 builds
+export BABELTRACE_DEBUG_MODE=1
+export BABELTRACE_DEV_MODE=1
+export BABELTRACE_MINIMAL_LOG_LEVEL=TRACE
+
+# Set configure options and environment variables for each build
+# configuration.
+CONF_OPTS=("--prefix=$PREFIX")
+
+# -Werror is enabled by default in stable-2.0 but won't be in 2.1
+# Explicitly disable it for consistency.
+if vergte "$PACKAGE_VERSION" "2.0"; then
+       CONF_OPTS+=("--disable-Werror")
+fi
+
 case "$conf" in
 static)
-    echo "Static build"
-    CONF_OPTS="--enable-static --disable-shared"
+    echo "Static lib only configuration"
+
+    CONF_OPTS+=("--enable-static" "--disable-shared")
+
+    if vergte "$PACKAGE_VERSION" "2.0"; then
+        CONF_OPTS+=("--enable-built-in-plugins")
+    fi
     ;;
+
 python-bindings)
-    echo "Build with python bindings"
-    # We only support bindings built with Python 3
-    export PYTHON="python3"
-    export PYTHON_CONFIG="/usr/bin/python3-config"
-    CONF_OPTS="--enable-python-bindings"
+    echo "Python bindings configuration"
+
+    CONF_OPTS+=("--enable-python-bindings")
+
+    if vergte "$PACKAGE_VERSION" "2.0"; then
+        CONF_OPTS+=("--enable-python-bindings-doc" "--enable-python-plugins")
+    fi
     ;;
-*)
-    echo "Standard build"
-    CONF_OPTS=""
+
+prod)
+    echo "Production configuration"
+
+    # Unset the developper variables
+    unset BABELTRACE_DEBUG_MODE
+    unset BABELTRACE_DEV_MODE
+    unset BABELTRACE_MINIMAL_LOG_LEVEL
+
+    # Enable the python bindings
+    CONF_OPTS+=("--enable-python-bindings" "--enable-python-plugins")
     ;;
-esac
 
+doc)
+    echo "Documentation configuration"
 
-# Run bootstrap prior to configure
-./bootstrap
+    CONF_OPTS+=("--enable-python-bindings" "--enable-python-bindings-doc" "--enable-python-plugins" "--enable-api-doc")
+    ;;
+
+asan)
+    echo "Address Sanitizer configuration"
+
+    # --enable-asan was introduced after 2.0 but don't check the version, we
+    # want this configuration to fail if ASAN is unavailable.
+    CONF_OPTS+=("--enable-asan" "--enable-python-bindings" "--enable-python-plugins")
+    ;;
 
+min)
+    echo "Minimal configuration"
+    ;;
+
+*)
+    echo "Standard configuration"
+
+    # Enable the python bindings / plugins by default with babeltrace2,
+    # the test suite is mostly useless without it.
+    if vergte "$PACKAGE_VERSION" "2.0"; then
+        CONF_OPTS+=("--enable-python-bindings" "--enable-python-plugins")
+    fi
+    ;;
+esac
 
 # Build type
-# oot : out-of-tree build
-# dist: build via make dist
-# *   : normal tree build
+# oot     : out-of-tree build
+# dist    : build via make dist
+# oot-dist: build via make dist out-of-tree
+# *       : normal tree build
 #
-# Make sure to move to the build_path and configure
-# before continuing
-BUILD_PATH=$WORKSPACE
-TEST_PLAN_PATH=$WORKSPACE
+# Make sure to move to the build directory and run configure
+# before continuing.
 case "$build" in
-    oot)
-        echo "Out of tree build"
-        BUILD_PATH=$WORKSPACE/oot
-        mkdir -p $BUILD_PATH
-        cd $BUILD_PATH
-        MAKE=$MAKE BISON="$BISON" YACC="$YACC" $WORKSPACE/configure --prefix=$PREFIX $CONF_OPTS
-        ;;
+oot)
+    echo "Out of tree build"
+
+    # Create and enter a temporary build directory
+    builddir=$(mktemp -d)
+    cd "$builddir"
+
+    "$SRCDIR/configure" "${CONF_OPTS[@]}" || failed_configure
+    ;;
+
+dist)
+    echo "Distribution in-tree build"
+
+    # Run configure and generate the tar file
+    # in the source directory
+    ./configure || failed_configure
+    $MAKE dist
+
+    # Create and enter a temporary build directory
+    builddir=$(mktemp -d)
+    cd "$builddir"
+
+    # Extract the distribution tar in the build directory,
+    # ignore the first directory level
+    $TAR xvf "$SRCDIR"/*.tar.* --strip 1
+
+    # Build in extracted source tree
+    ./configure "${CONF_OPTS[@]}" || failed_configure
+    ;;
 
-    dist)
-        echo "Distribution out of tree build"
-        BUILD_PATH=`mktemp -d`
+oot-dist)
+    echo "Distribution out of tree build"
 
-        # Initial configure and generate tarball
-        MAKE=$MAKE BISON="$BISON" YACC="$YACC" ./configure
-        $MAKE dist
+    # Create and enter a temporary build directory
+    builddir=$(mktemp -d)
+    cd "$builddir"
 
-        mkdir -p $BUILD_PATH
-        cp *.tar.* $BUILD_PATH/
-        cd $BUILD_PATH
+    # Run configure out of tree and generate the tar file
+    "$SRCDIR/configure" || failed_configure
+    $MAKE dist
 
-        # Ignore level 1 of tar
-        $TAR xvf *.tar.* --strip 1
+    dist_srcdir="$(mktemp -d)"
+    cd "$dist_srcdir"
 
-        MAKE=$MAKE BISON="$BISON" YACC="$YACC" $BUILD_PATH/configure --prefix=$PREFIX $CONF_OPTS
+    # Extract the distribution tar in the new source directory,
+    # ignore the first directory level
+    $TAR xvf "$builddir"/*.tar.* --strip 1
 
-        # Set test plan to dist tar
-        TEST_PLAN_PATH=$BUILD_PATH
-        ;;
+    # Create and enter a second temporary build directory
+    builddir="$(mktemp -d)"
+    cd "$builddir"
+
+    # Run configure from the extracted distribution tar,
+    # out of the source tree
+    "$dist_srcdir/configure" "${CONF_OPTS[@]}" || failed_configure
+    ;;
 
 *)
-        echo "Standard tree build"
-        MAKE=$MAKE BISON="$BISON" YACC="$YACC" $WORKSPACE/configure --prefix=$PREFIX $CONF_OPTS
-        ;;
+    echo "Standard in-tree build"
+    ./configure "${CONF_OPTS[@]}" || failed_configure
+    ;;
 esac
 
+# We are now inside a configured build directory
+
 # BUILD!
-$MAKE -j `$NPROC` V=1
-$MAKE install
+$MAKE -j "$($NPROC)" V=1
+
+# Install in the workspace
+$MAKE install DESTDIR="$WORKSPACE"
 
-# Run tests
-$MAKE check
+# Run tests, don't fail now, we want to run the archiving steps
+failed_tests=0
+if [ "$BABELTRACE_RUN_TESTS" = "yes" ]; then
+       $MAKE --keep-going check || failed_tests=1
 
+       # Copy tap logs for the jenkins tap parser before cleaning the build dir
+       rsync -a --exclude 'test-suite.log' --include '*/' --include '*.log' --exclude='*' tests/ "$WORKSPACE/tap"
+
+       # The test suite prior to 1.5 did not produce TAP logs
+       if verlt "$PACKAGE_VERSION" "1.5"; then
+           mkdir -p "$WORKSPACE/tap/no-log"
+           echo "1..1" > "$WORKSPACE/tap/no-log/tests.log"
+           echo "ok 1 - Test suite doesn't support logging" >> "$WORKSPACE/tap/no-log/tests.log"
+       fi
+fi
+
+# Clean the build directory
 $MAKE clean
 
 # Cleanup rpath in executables and shared libraries
-find $WORKSPACE/build/bin -type f -perm -0500 -exec chrpath --delete {} \;
-find $WORKSPACE/build/lib -name "*.so" -exec chrpath --delete {} \;
+find "$WORKSPACE/$PREFIX/bin" -type f -perm -0500 -exec chrpath --delete {} \;
+find "$WORKSPACE/$PREFIX/lib" -name "*.so" -exec chrpath --delete {} \;
 
 # Remove libtool .la files
-find $WORKSPACE/build/lib -name "*.la" -exec rm -f {} \;
+find "$WORKSPACE/$PREFIX/lib" -name "*.la" -exec rm -f {} \;
 
-# Clean temp dir for dist build
-if [ "$build" = "dist" ]; then
-    cd $WORKSPACE
-    rm -rf $BUILD_PATH
-fi
+# Exit with failure if any of the tests failed
+exit $failed_tests
 
 # EOF
This page took 0.026308 seconds and 4 git commands to generate.